function  writeOceanScript_64B(filename, leak_start, leak_end, write_start, write_end, read_start, read_end)
%generates an OCEAN file for use in Kai Likne's testbenches of a D-flip-flop
%REFDFF
%64 byte RAM circuit

%% leakage currents
fileID = fopen(filename,'w');
fprintf(fileID,'axlOutputResult("-----" "--- Leakage Currents ---")\n\n');

fprintf(fileID,'leak_peripheral = average(clip(IT("/I_PERIPHERAL_PROBE/PLUS") %sn %sn ))\n',leak_start,leak_end);
fprintf(fileID,'leak_cells = average(clip(IT("/I_CELLS_PROBE/PLUS") %sn %sn ))\n',leak_start,leak_end);
fprintf(fileID,'leak_total = leak_peripheral + leak_cells\n');

fprintf(fileID,'\naxlOutputResult(leak_peripheral "leak_peripheral (A)")\n');
fprintf(fileID,'axlOutputResult(leak_cells "leak_cells (A)")\n');
fprintf(fileID,'axlOutputResult(leak_total "leak_total (A)")\n');

%% write energy
fprintf(fileID,'\naxlOutputResult("-----" "--- Write energy ---")\n\n');

fprintf(fileID,'write_energy_peripheral = integ(clip(IT("/I_PERIPHERAL_PROBE/PLUS") %sn %sn )) * VAR("VDD_VAL")\n',write_start,write_end);
fprintf(fileID,'write_energy_cells = integ(clip(IT("/I_CELLS_PROBE/PLUS") %sn %sn )) * VAR("VDD_VAL")\n',write_start,write_end);
fprintf(fileID,'write_energy_total = write_energy_peripheral + write_energy_cells\n');

fprintf(fileID,'\naxlOutputResult(write_energy_peripheral "write_energy_peripheral (J)")\n');
fprintf(fileID,'axlOutputResult(write_energy_cells "write_energy_cells (J)")\n');
fprintf(fileID,'axlOutputResult(write_energy_total "write_energy_total (J)")\n');

%% read energy
fprintf(fileID,'\naxlOutputResult("-----" "--- Read energy ---")\n\n');

fprintf(fileID,'read_energy_peripheral = integ(clip(IT("/I_PERIPHERAL_PROBE/PLUS") %sn %sn )) * VAR("VDD_VAL")\n',read_start,read_end);
fprintf(fileID,'read_energy_cells = integ(clip(IT("/I_CELLS_PROBE/PLUS") %sn %sn )) * VAR("VDD_VAL")\n',read_start,read_end);
fprintf(fileID,'read_energy_total = read_energy_peripheral + read_energy_cells\n');

fprintf(fileID,'\naxlOutputResult(read_energy_peripheral "read_energy_peripheral (J)")\n');
fprintf(fileID,'axlOutputResult(read_energy_cells "read_energy_cells (J)")\n');
fprintf(fileID,'axlOutputResult(read_energy_total "read_energy_total (J)")\n');

fclose(fileID);
end

