function  writeStimAndOceanFile_avgleaktest( filename )
%generates a STIM file for use in Kai Likne's testbenches of a 6T SRAM
%64 byte circuit
%% constants and initialization:
hier = '0';
tunit = 'ns';
trise = '0.001' ; %100ps falltime/risetime
tfall = '0.001' ;
vih = '3';
vil = '0';
period = 100; %10Mhz clock freq, 100ns period
wait_time = 500000000; %0.5 second wait time to measure leak

time = '000000000000';
time_amount_of_digits = length(time); %has to be 12
maxtime = 10^(time_amount_of_digits);

%% intialize ocean file
ocean_fileID = fopen(strcat(filename,'.ocn'),'w');
fprintf(ocean_fileID,'axlOutputResult("-----" "--- Leakage Currents ---")\n\n');




%% start writing file
fileID = fopen(strcat(filename,'.vec'),'w');

fprintf(fileID,'radix\n');
fprintf(fileID,'+ 1 1 1 1\n');
fprintf(fileID,'\nio\n');
fprintf(fileID,'+ i i i i\n\n');
fprintf(fileID,'hier %s\ntunit %s\ntrise %s\ntfall %s\nvih %s\nvil %s\n\n', hier, tunit, trise, tfall, vih, vil);
fprintf(fileID,'\nvname\n+INPUT3 INPUT2 INPUT1 INPUT0\n\n');


fprintf(fileID,'\n\n\n; Initializing\n\n');
fprintf(fileID,';time\t\t\tin3\tin2\tin1\tin0\n');
fprintf(fileID,'%s\t\t%s\t%s\t%s\t%s ;\n',time,'0','0','0','0');
time = sprintf('%012d',str2num(time)+period); %timestep 1 clock period


for vector_value = 0:15
   vector = dec2bin(vector_value,4);
 
   
   in3 = vector(1);
   in2 = vector(2);
   in1 = vector(3);
   in0 = vector(4);
   
   %write stim part
   fprintf(fileID,'%s\t\t%s\t%s\t%s\t%s ;\n',time,in3,in2,in1,in0);
   time = sprintf('%012d',str2num(time)+wait_time);
   start = time;
   time = sprintf('%012d',str2num(time)+ 2* period);
   stop = time;
   time = sprintf('%012d',str2num(time)+ 2* period);
   
   %write ocean part
   fprintf(ocean_fileID,'average_%s = average(clip(IT("/I_PROBE/PLUS") %sn %sn ))\n',num2str(vector_value),start,stop);
   fprintf(ocean_fileID,'axlOutputResult(average_%s "average leak with value %s (A)")\n\n', num2str(vector_value), num2str(vector_value));
   
end

%finish up ocean part
%fourinputs
fprintf(ocean_fileID,'axlOutputResult("-----" "--- Overall average leakage currents ---")\n\n');
fprintf(ocean_fileID,'average_fourinputs = ( average_0 ');
for j = 1:15
    fprintf(ocean_fileID,'+ average_%s ',num2str(j));
end
fprintf(ocean_fileID,')/16\n');
fprintf(ocean_fileID,'axlOutputResult(average_fourinputs "average leak with four inputs (A)")\n\n');

%threeinputs
fprintf(ocean_fileID,'average_threeinputs = ( average_0 ');
for j = 1:7
    fprintf(ocean_fileID,' + average_%s ',num2str(j));
end
fprintf(ocean_fileID,')/8 \n');
fprintf(ocean_fileID,'axlOutputResult(average_threeinputs "average leak with three inputs (A)")\n\n');

%twoinputs
fprintf(ocean_fileID,'average_twoinputs = ( average_0 ');
for j = 1:3
    fprintf(ocean_fileID,'+ average_%s ',num2str(j));
end
fprintf(ocean_fileID,')/4 \n');
fprintf(ocean_fileID,'axlOutputResult(average_twoinputs "average leak with two inputs (A)")\n\n');

%oneinput
fprintf(ocean_fileID,'average_oneinput = ( average_0 ');
for j = 1:1
    fprintf(ocean_fileID,'+ average_%s ',num2str(j));
end
fprintf(ocean_fileID,')/ 2\n');
fprintf(ocean_fileID,'axlOutputResult(average_oneinput "average leak with one input (A)")\n\n');

fclose(ocean_fileID);
fclose(fileID);
end

